/*
Name:	 Touch_Extension_FP2.ino
Created: 03.12.2017 15:03:18
Author:	 Kirschner Christoph
*/

#include <HID.h>
#include <HID-Project.h>
#include <CapacitiveSensor.h>

const char led[3] = { 6,8,9 };
const char chargePins[3] = { 13,10,5 };
const char sensorPins[3] = { A0,A1,A2 };

bool buttonPressed1 = false; // volume up
bool buttonPressed2 = false; // power-button
bool buttonPressed3 = false; // volume down

int firstPress1 = 0; // first press of button 1 aka volume up
int firstPress2 = 0; // first press of button 2 aka wake screen/ sleep screen
int firstPress3 = 0; // first press of button 3 aka volume down

bool screenCase = true;

CapacitiveSensor   cs_13_A0 = CapacitiveSensor(13, A0);
CapacitiveSensor   cs_5_A1 = CapacitiveSensor(5, A1);
CapacitiveSensor   cs_10_A2 = CapacitiveSensor(10, A2);

byte total1 = 0; // touch-sensor output in numbers
byte total2 = 0;
byte total3 = 0;

byte total1Old = 0;
byte total2Old = 1;
byte total3Old = 2;

byte byteRecieved = 0;

void setup() {
	Consumer.begin();
	System.begin();
	Keyboard.begin();

	pinMode(chargePins[0], OUTPUT); // charging pins
	pinMode(chargePins[1], OUTPUT);
	pinMode(chargePins[2], OUTPUT);

	pinMode(sensorPins[0], INPUT); // sensor pins
	pinMode(sensorPins[1], INPUT);
	pinMode(sensorPins[2], INPUT);

	pinMode(led[0], OUTPUT); // led pins
	pinMode(led[1], OUTPUT);
	pinMode(led[2], OUTPUT);
}

void loop() {
	checkButtons();
	serialInterface(0, false);
	compareValues();

	/*if (total1 > 100) { digitalWrite(led[0], HIGH); } // lighting up the right leds
	else { digitalWrite(led[0], LOW); }
	if (total2 > 100) { digitalWrite(led[1], HIGH); }
	else { digitalWrite(led[1], LOW); }
	if (total3 > 100) { digitalWrite(led[2], HIGH); }
	else { digitalWrite(led[2], LOW); }*/
}

void checkButtons() {
	 total1 = cs_13_A0.capacitiveSensor(30); // touch-sensor output in numbers
	 total2 = cs_5_A1.capacitiveSensor(30);
	 total3 = cs_10_A2.capacitiveSensor(30);

	int time = millis();
	if (total3 > 100 && buttonPressed1 == false) {
		firstPress1 = millis();
		buttonPressed1 = true;
	}
	if (total3 < 50 && buttonPressed1 == true) {
		if (time - firstPress1 > 50) {
			Consumer.write(MEDIA_VOL_UP); // HID code for volume up
		}
		buttonPressed1 = false;
	}
	time = millis();
	if (total2 > 100 && buttonPressed2 == false) {
		firstPress2 = millis();
		buttonPressed2 = true;
	}
	if (total2 < 50 && buttonPressed2 == true) {
		if (time - firstPress2 > 50) {
			Keyboard.write(CONSUMER_POWER);  // HID code for power-button
		}
		buttonPressed2 = false;
	}
	time = millis();
	if (total1 > 100 && buttonPressed3 == false) {
		firstPress3 = millis();
		buttonPressed3 = true;
	}
	if (total1 < 50 && buttonPressed3 == true) {
		if (time - firstPress3 > 50) {
			Consumer.write(MEDIA_VOL_DOWN); // HID code for volume down		
		}
		buttonPressed3 = false;
	}
}

void compareValues() {
	if (abs(total1 - total1Old) > 40) {
		serialInterface(total1, true);
		total1Old = total1;
	}
}

void serialInterface(byte sensorData, bool send) {
	if (Serial.available() > 0 && !send) {
		byteRecieved = Serial.read();
		lightLED();
	}else
	if (send) {
		Serial.print(sensorData);
		delay(100);
	}
}

void lightLED() {
	digitalWrite(led[0], bitRead(byteRecieved, 0)); 
	digitalWrite(led[1], bitRead(byteRecieved, 1));
	digitalWrite(led[2], bitRead(byteRecieved, 2));	
}



